#import <simtools.h>     // initSwarm () and swarmGUIMode
#import <simtoolsgui.h>  // GUISwarm
#import "ManagerSwarm.h"
#import "HeatbugObserverSwarm.h"
#import "HeatbugModelSwarm.h"

@implementation ManagerSwarm
+ createBegin: aZone
{
   ManagerSwarm *obj;
   id <ProbeMap> probeMap=nil;
  
  // Superclass createBegin to allocate ourselves.

  obj = [super createBegin: aZone];

 
  //  obj->displayFrequency = 1;

 //  probeMap = [EmptyProbeMap createBegin: aZone];
//   [probeMap setProbedClass: [self class]];
//   probeMap = [probeMap createEnd];

  // Add in a bunch of variables, one per simulation parameters
   [probeLibrary setProbeMap: probeMap For: [self class]];
 return obj;
}

- createEnd
{
 
  return [super createEnd];
}

-buildModel
{  

    heatbugObserverSwarm = [HeatbugObserverSwarm createBegin: self];
       SET_WINDOW_GEOMETRY_RECORD_NAME (heatbugObserverSwarm);
    heatbugObserverSwarm = [ heatbugObserverSwarm createEnd ];

    [heatbugObserverSwarm buildObjects];

    [heatbugObserverSwarm buildActions];

    [heatbugObserverSwarm activateIn: nil];
      
  return self;
}

-runModel
{

/*     while ([[heatbugObserverSwarm getControl]   getState] != ControlStateQuit)
     {
	if ( [[heatbugObserverSwarm getControl] getState] == ControlStateRunning) 
         [[heatbugObserverSwarm getActivity] run];
        if ( [[heatbugObserverSwarm getControl] getState] == ControlStateStopped)
          {
         [[heatbugObserverSwarm getActivity] stop];
         [ actionCache waitForControlEvent];
          }
      } 

*/
     [heatbugObserverSwarm go]; 
    return self;
}

- dropModel
{
  [[heatbugObserverSwarm getActivity] terminate];
  [heatbugObserverSwarm dropObjects];
  [probeDisplayManager dropProbeDisplaysFor: heatbugObserverSwarm];
  [[heatbugObserverSwarm getActivity] drop];  
  
  [heatbugObserverSwarm drop];
 
  return self;
}

-buildObjects
{
  [super buildObjects];
  [controlPanel setStateStopped];
   return self;
  
}

-buildActions
{
 [super buildActions];

  projectActions = [ActionGroup create: self];

  // Schedule up the methods to  build the model, run it, collect data,
  // display the data, log the results, and drop the model.  

  [projectActions createActionTo: self	message: M(buildModel)];

  [projectActions createActionTo: self	message: M(runModel)];
 
  [projectActions createActionTo: self	message: M(dropModel)];

  [projectActions  createActionTo: probeDisplayManager message: M(update)];
  [projectActions createActionTo: actionCache          message: M(doTkEvents)];
  projectSchedule = [Schedule createBegin: self];
  [projectSchedule setRepeatInterval: 1];
  projectSchedule = [projectSchedule createEnd];
  [projectSchedule at: 0 createAction: projectActions];
return self;

}

-activateIn: swarmContext
{  
  [super activateIn: swarmContext]; 
    [projectSchedule activateIn: self];
 
  return [self getActivity];
}



@end
